//Library to create canulas (siphons) to connect reactors

//vio vertical space between input and output
//len horizontal space between input and output
//d   diameter of the tube
//t   thickness of the walls

use <lib_bend_pipe.scad>


module canula(vio, len, d, t)
{
    height = vio + d + 2 * t;
    width = d + 2 * t;

    difference()
    {
        cube([width, len + 2, height]);
        translate([width / 2, len / 2 + 1, d / 2 + t + len / 2]) cylinder(d=d, h=vio - len);

        translate([width / 2, 1, d / 2 + t]) rotate([90, 0, 0]) cylinder(d=d, h=1);

        translate([width / 2, 1, d / 2 + t + len / 2]) rotate([0, 90, 0]) bend_pipe(ed=d, id=0, r=len / 2, quarter=true);
        echo("Canula, height for bottom opening:", d / 2 + t);

        translate([width / 2, len + 2, d / 2 + t + vio]) rotate([90, 0, 0]) cylinder(d=d, h=1);
        translate([width / 2, len + 1, d / 2 + t - len / 2 + vio]) rotate([0, -90, 180]) bend_pipe(ed=d, id=0, r=len / 2, quarter=true);
        echo("Canula, height for top opening:", d / 2 + vio);
    }
}

//More segments, higher definition
$fn=100;

canula(vio=40, len=10, d=3, t=3);
